local anim8 = require "anim8"


function getNewCharacter(world,posX,posY)

	local instance = {}
	instance.isJumping = false
	instance.img = love.graphics.newImage("littleGirl.png")

	instance.direction = 1

	instance.grid = anim8.newGrid(36, 45, instance.img:getWidth(), instance.img:getHeight())

	instance.bounds = { x=0 , y=0 , width = 36 , height = 45 }

	instance.animation = anim8.newAnimation('bounce',instance.grid('1-3,2'),0.1)

	instance.body = love.physics.newBody(world,posX,posY,"dynamic")
	
	instance.body:setMass(10)
	
	--instance.shape = love.physics.newRectangleShape(instance.bounds.width / 2,instance.bounds.height / 2, instance.bounds.width, instance.bounds.height)
	--[[instance.shape = love.physics.newPolygonShape(0,0,
												  instance.bounds.width,0,
												  instance.bounds.width,30,
												  instance.bounds.width/2,instance.bounds.height,
												  0,30)]]

	instance.shape = love.physics.newCircleShape(20)
	instance.fixture = love.physics.newFixture(instance.body,instance.shape)
	
	instance.fixture:setFriction(1)
	instance.body:setAngularDamping( 1000 )
	
	instance.body:setFixedRotation(false)
	
	instance.update = function (dt)
	
		local needAnimate = false
		
		speedX,speedY = instance.body:getLinearVelocity()
		
		if love.keyboard.isDown("d") then
			if instance.direction == -1 then
					instance.direction = 1
					instance.animation = anim8.newAnimation('bounce',instance.grid('1-3,2'),0.1)
				end
			instance.body:applyForce(400,0)
			needAnimate = true
		end
		
		if love.keyboard.isDown("w") and (speedY > -0.05 and speedY < 0.05 and not instance.isJumping) then
			instance.body:applyLinearImpulse(0,-300)
			instance.body:applyForce(speedX,0)
			instance.isJumping = true
		end
		
		if love.keyboard.isDown("a") then
				if instance.direction == 1 then
					instance.direction = -1
					instance.animation = anim8.newAnimation('bounce',instance.grid('1-3,1'),0.1)
				end
				instance.body:applyForce(-400,0)
				needAnimate = true
		end
		
		if(needAnimate) then
			instance.animation:update(dt)
		else
			instance.animation:gotoFrame(2)
		end
	end
	
	return instance
	
end



local charFactory = {
	getNewCharacter = getNewCharacter
}
return charFactory