local charFactory = require "charFactory"
local objFactory = require "objectFactory"

local world = love.physics.newWorld(0,9.8 * 64,true)

local mainChar 

local objects = {}

local noColisionObjects = {}

local backGround = {}

local map

function load()
	love.physics.setMeter(64)
	
	map = objFactory.getNewMap(world,5,5)
	
	mainChar = charFactory.getNewCharacter(world,600,400)	
	
	world:setCallbacks(beginContact)

	noColisionObjects[#noColisionObjects + 1] = objFactory.getNewTree(world,400,420)
	
	objects[#objects + 1] = objFactory.getNewBox(world,nil,240,0,"dynamic")
	objects[#objects + 1] = objFactory.getNewBox(world,nil,240,100,"dynamic")
	objects[#objects + 1] = objFactory.getNewBox(world,nil,240,150,"dynamic")
	objects[#objects + 1] = objFactory.getNewBox(world,nil,240,200,"dynamic")
	objects[#objects + 1] = objFactory.getNewBox(world,nil,200,400,"dynamic")

	
	objects[#objects + 1] = objFactory.getNewGround(world,nil,0,560,"static")
	
	backGround.img = love.graphics.newImage("/Backgrounds/backGround.png")
	
end


function update(dt)
	world:update(dt)
	mainChar.update(dt)
end

function draw()
	love.graphics.draw(backGround.img, 0,0)

	for i=1,#noColisionObjects,1 do
		love.graphics.draw(noColisionObjects[i].img,noColisionObjects[i].position.x,noColisionObjects[i].position.y)
	end
	
	for i=1,#objects,1 do
		x , y = objects[i].body:getPosition()
		love.graphics.draw(objects[i].img,x,y,objects[i].body:getAngle())
	end
	
	local x , y = mainChar.body:getPosition()
	mainChar.animation:draw(mainChar.img, x , y)

	love.graphics.circle("fill", mainChar.body:getX(), mainChar.body:getY(),20,20)

	for i = 1,5,1 do
		for j = 1,5,1 do
			love.graphics.draw(map.img,map.map[i][j].body:getX(),map.map[i][j].body:getY())
		end
	end
	
end


---------------Updates----------------


---------------Gets-------------------

function getObjects()
	return objects
end

-----------------Physics-------------

function beginContact(a, b, coll)
	mainChar.isJumping = false
end

function endContact(a, b, coll)
    
end

function preSolve(a, b, coll)
    
end

function postSolve(a, b, coll)
    
end

------------------------------------------------------------------------
local gameManager = {
	load = load,
	update = update,
	draw = draw,
	addObject = addObject
}
return gameManager
